// Generated by CoffeeScript 2.3.2
(function() {
  var L, hostname, renderable,
    hasProp = {}.hasOwnProperty;

  ({renderable} = L = require('acoustic-line'));

  ({hostname} = require('os'));

  module.exports = renderable(function(cfg) {
    var callerControls, configuration, control, doctype, document, global_settings, group, list, load, macros, map, mappings, module, modules, modules_to_load, name, network_lists, node, param, params, phrases_to_load, profile, profiles, ref, ref1, ref2, section, settings, the_profiles;
    ({doctype, document, section, configuration, settings, params, param, modules, module, load, network_lists, list, node, global_settings, profiles, profile, mappings, map, macros, callerControls, group, control} = L);
    // cfg.name (string) Internal name for the FreeSwitch instance
    name = (ref = cfg.name) != null ? ref : 'server';
    // cfg.profiles (object) Maps profile name to profile definition (containg cfg.profiles[].sip_port, cfg.profiles[].socket_port, etc.)
    // cfg.profiles.sbc (object) The default profile for the huge-play module, defaults to using `sip_port` 5080 and `socket_port` 5721.
    the_profiles = (ref1 = cfg.profiles) != null ? ref1 : {
      sbc: {
        sip_port: 5080,
        socket_port: 5721 // Outbound-Socket port
      }
    };
    modules_to_load = ['mod_event_socket', 'mod_commands', 'mod_dptools', 'mod_loopback', 'mod_sofia', 'mod_sndfile', 'mod_tone_stream', 'mod_httapi'];
    // cfg.cdr.url (URL) where to push FreeSwitch CDRs
    if (((ref2 = cfg.cdr) != null ? ref2.url : void 0) != null) {
      modules_to_load.push('mod_json_cdr');
    }
    // cfg.modules (array) extraneous modules for FreeSwitch
    if (cfg.modules != null) {
      modules_to_load = modules_to_load.concat(cfg.modules);
    }
    phrases_to_load = [require('bumpy-lawyer/en'), require('bumpy-lawyer/fr')];
    // cfg.phrases (array) extraneous language phrase (such as those provided by the bumpy-lawyer project) for FreeSwitch
    if (cfg.phrases != null) {
      phrases_to_load = phrases_to_load.concat(cfg.phrases);
    }
    doctype();
    return document({
      type: 'freeswitch/xml'
    }, function() {
      var ref3, sound_dir;
      section({
        name: 'configuration'
      }, function() {
        var ref3;
        configuration({
          name: 'switch.conf'
        }, function() {
          return settings(function() {
            var ref3;
            // cfg.host (hostname) used preferentially to the automatically-determined hostname for FreeSwitch
            param({
              name: 'switchname',
              value: `freeswitch-${name}@${(ref3 = cfg.host) != null ? ref3 : hostname()}`
            });
            param({
              name: 'core-db-name',
              value: `/dev/shm/freeswitch/core-${name}.db`
            });
            param({
              name: 'rtp-start-port',
              value: 49152
            });
            param({
              name: 'rtp-end-port',
              value: 65534
            });
            param({
              name: 'max-sessions',
              value: 2000
            });
            param({
              name: 'sessions-per-second',
              value: 2000
            });
            param({
              name: 'min-idle-cpu',
              value: 1
            });
            return param({
              name: 'loglevel',
              value: 'err'
            });
          });
        });
        configuration({
          name: 'modules.conf'
        }, function() {
          return modules(function() {
            var i, len, results;
            results = [];
            for (i = 0, len = modules_to_load.length; i < len; i++) {
              module = modules_to_load[i];
              results.push(load({module}));
            }
            return results;
          });
        });
        configuration({
          name: 'logfile.conf'
        }, function() {
          settings(function() {
            return param({
              name: 'rotate-on-hup',
              value: true
            });
          });
          return profiles(function() {
            return profile({
              name: 'default'
            }, function() {
              settings(function() {
                param({
                  name: 'logfile',
                  value: "log/freeswitch.log"
                });
                param({
                  name: 'rollover',
                  value: 10 * 1000 * 1000
                });
                return param({
                  name: 'uuid',
                  value: true
                });
              });
              return mappings(function() {
                return map({
                  name: 'important',
                  value: 'err,crit,alert'
                });
              });
            });
          });
        });
        configuration({
          name: 'event_socket.conf'
        }, function() {
          return settings(function() {
            var ref3, ref4;
            param({
              name: 'nat-map',
              value: false
            });
            // Inbound-Socket IP
            // cfg.socket_ip (string) IP to bind to for the event socket (defaults to `127.0.0.1`)
            param({
              name: 'listen-ip',
              value: (ref3 = cfg.socket_ip) != null ? ref3 : '127.0.0.1'
            });
            // Inbound-Socket port
            // cfg.socket_port (integer) Port for the event socket for FreeSwitch (defaults to 5722)
            param({
              name: 'listen-port',
              value: (ref4 = cfg.socket_port) != null ? ref4 : 5722
            });
            if (cfg.socket_acl != null) {
              param({
                name: 'apply-inbound-acl',
                value: cfg.socket_acl
              });
            }
            return param({
              name: 'password',
              value: 'ClueCon'
            });
          });
        });
        configuration({
          name: "acl.conf"
        }, function() {
          return network_lists(function() {
            var cidrs, ref3, results;
            ref3 = cfg.acls;
            // cfg.acls (object) Maps ACL names to cfg.acls[].cidrs arrays for FreeSwitch.
            results = [];
            for (name in ref3) {
              cidrs = ref3[name];
              results.push(list({
                name: name,
                default: 'deny'
              }, function() {
                var cidr, i, len, results1;
                results1 = [];
                for (i = 0, len = cidrs.length; i < len; i++) {
                  cidr = cidrs[i];
                  results1.push(node({
                    type: 'allow',
                    cidr: cidr
                  }));
                }
                return results1;
              }));
            }
            return results;
          });
        });
        configuration('fifo.conf', function() {
          return settings(function() {
            return param('delete-all-outbound-member-on-startup', true);
          });
        });
        if (((ref3 = cfg.cdr) != null ? ref3.url : void 0) != null) {
          configuration({
            name: 'json_cdr.conf'
          }, function() {
            return settings(function() {
              var ref4, ref5, ref6, ref7, ref8;
              // cfg.cdr.auth_scheme (string) Authentication scheme for FreeSwitch CDR (default: "basic")
              // cfg.cdr.encode_values (boolean) Whether to encode values for FreeSwitch CDR (default: false)
              // cfg.cdr.log_dir (string) JSON FreeSwitch CDR logging directory (default: "cdr")
              // cfg.cdr.log_b_leg (boolean) Whether to log on the b-leg for FreeSwitch CDR (default: false)
              // cfg.cdr.cred (string) Credentails for FreeSwitch CDR (default: '')
              param({
                name: 'auth-scheme',
                value: (ref4 = cfg.cdr.auth_scheme) != null ? ref4 : 'basic'
              });
              param({
                name: 'encode-values',
                value: (ref5 = cfg.cdr.encode_values) != null ? ref5 : false
              });
              param({
                name: 'log-dir',
                value: (ref6 = cfg.cdr.log_dir) != null ? ref6 : 'cdr'
              });
              param({
                name: 'log-b-leg',
                value: (ref7 = cfg.cdr.log_b_leg) != null ? ref7 : false
              });
              param({
                name: 'cred',
                value: (ref8 = cfg.cdr.cred) != null ? ref8 : ''
              });
              return param({
                name: 'url',
                value: cfg.cdr.url
              });
            });
          });
        }
        configuration({
          name: 'sofia.conf'
        }, function() {
          global_settings(function() {
            param({
              name: 'log-level',
              value: 1
            });
            return param({
              name: 'debug-presence',
              value: 0
            });
          });
          return profiles(function() {
            var k, p, profile_module, q, ref4, ref5, ref6, results, v;
            // cfg.profile_module (Node.js module) module to use to build Sofia profiles (default: huge-play's)
            profile_module = (ref4 = cfg.profile_module) != null ? ref4 : require('./profile');
            results = [];
            for (name in the_profiles) {
              p = the_profiles[name];
              // cfg.profiles[].timer_t1 (integer) SIP timer T1 for FreeSwitch (default: 250)
              // cfg.profiles[].timer_t1x64 (integer) SIP timer T1*64 for FreeSwitch (default: 64*timer_t1)
              // cfg.profiles[].timer_t2 (integer) SIP timer T2 for FreeSwitch (default: 4000)
              // cfg.profiles[].timer_t4 (integer) SIP timer T4 for FreeSwitch (default: 5000)
              // Timer values see http://tools.ietf.org/html/rfc3261#page-265
              if (p.timer_t1 == null) {
                p.timer_t1 = 250; // 500ms in RFC3261; works well in practice
              }
              if (p.timer_t4 == null) {
                p.timer_t4 = 5000; // RFC3261 section 17.1.2.2
              }
              if (p.timer_t2 == null) {
                p.timer_t2 = 4000; // RFC3261 section 17.1.2.2
              }
              if (p.timer_t1x64 == null) {
                p.timer_t1x64 = 64 * p.timer_t1;
              }
              // Note: p.local_ip is defaulted by huge-play:middleware:carrier:setup to p.ingress_sip_ip
              // cfg.profiles[].local_ip (string) local binding IP for SIP for FreeSwitch. Defaults to `auto`, except for huge-play's carrier configuration where it defaults to cfg.profiles[].ingress_sip_ip
              if (p.local_ip == null) {
                p.local_ip = 'auto';
              }
              // cfg.profiles[].inbound_codec (string) inbound codec list. Default: `PCMA`.
              // cfg.profiles[].inbound_codec_negotiation (string) inbound codec negotiation (one of `scrooge`, `greedy`, `generous`). Default: `scrooge`.
              // cfg.profiles[].outbound_codec (string) outbound codec list. Default: `PCMA`.
              // cfg.profiles[].acl (string) SIP port ACL name (default: `default`) If cfg.profiles[].acl_per_profile is set, the name default to the profile's `<name>-ingress` or `<name>-egress` name, instead.
              if (p.inbound_codec == null) {
                p.inbound_codec = 'PCMA';
              }
              if (p.inbound_codec_negotiation == null) {
                p.inbound_codec_negotiation = 'scrooge';
              }
              if (p.outbound_codec == null) {
                p.outbound_codec = 'PCMA';
              }
              if (p.acl == null) {
                p.acl = 'default';
              }
              if (p.sip_trace == null) {
                p.sip_trace = false;
              }
              q = {};
              for (k in p) {
                if (!hasProp.call(p, k)) continue;
                v = p[k];
                q[k] = v;
              }
              // cfg.profiles[] Each profile's name is used to build two names, `<name>-ingress` and `<name>-egress`. These names are used as the actual profile names (in huge-play) and the target dialplan context name (also as the ACL name, if `acl_per_profile` is set).
              // cfg.profiles[].sip_port (integer) The SIP port for the ingress profile defaults to the profile's cfg.profiles[].ingress_sip_port or the cfg.profiles[].sip_port value. The SIP port for the egress profile defaults to the profile's cfg.profiles[].egress_sip_port, or 10000 plus the ingress SIP port.
              // cfg.profiles[].ingress_sip_port (integer) Ingress SIP port. (default: cfg.profiles[].sip_port )
              // cfg.profiles[].egress_sip_port (integer) Egress SIP port. (default: 10000 + the Ingress SIP port )
              // cfg.profiles[].client (boolean) if true, transfers (REFER) are allowed on the egress (client-facing) profile. Default: false.

              // Ingress profile (carrier-side) is at port `sip_port`.
              q.name = q.context = `${name}-ingress`;
              q.sip_port = (ref5 = p.ingress_sip_port) != null ? ref5 : p.sip_port;
              if (cfg.acl_per_profile) {
                q.acl = q.name;
              }
              // Transfers must be allowed carrier-side so that e.g. we can redirect to the proper conference server
              q.disable_transfer = q.client !== true;
              profile_module.call(L, q);
              // Egress profile (client-side) is at port 'sip_port+10000'.
              q.name = q.context = `${name}-egress`;
              q.sip_port = (ref6 = p.egress_sip_port) != null ? ref6 : 10000 + q.sip_port;
              if (cfg.acl_per_profile) {
                q.acl = q.name;
              }
              q.disable_transfer = false;
              results.push(profile_module.call(L, q));
            }
            return results;
          });
        });
        configuration({
          name: 'httapi.conf'
        }, function() {
          settings(function() {
            return '';
          });
          return profiles(function() {
            // In mod_httapi.c/fetch_cache_data(), the profile_name might be set as a parameter, a setting, or defaults to `default`.
            return profile({
              name: 'default'
            }, function() {
              return params(function() {
                var ref4, ref5, ref6, ref7, ref8, ref9;
                // cfg.httapi_url (URL) URL for the HTTAPI service for FreeSwitch (default: '')
                // cfg.httapi_credentials (string) Credentials for the HTTAPI service for FreeSwitch (default: '')
                // cfg.httapi_authscheme (string) Authentication scheme for the HTTAPI service for FreeSwitch (default: 'basic')
                // cfg.httapi_cacert_check (boolean) Enable CA certificate check for the HTTAPI service for FreeSwitch (default: true)
                // cfg.httapi_verify_host (boolean) Enable host verification for the HTTAPI service for FreeSwitch (default: true)
                // cfg.httapi_timeout (integer) Timeout for the HTTAPI service for FreeSwitch (default: 120)
                param('gateway-url', (ref4 = cfg.httapi_url) != null ? ref4 : '');
                param('gateway-credentials', (ref5 = cfg.httapi_credentials) != null ? ref5 : '');
                param('auth-scheme', (ref6 = cfg.httapi_authscheme) != null ? ref6 : 'basic');
                param('enable-cacert-check', (ref7 = cfg.httapi_cacert_check) != null ? ref7 : true);
                param('enable-ssl-verifyhost', (ref8 = cfg.httpapi_verify_host) != null ? ref8 : true);
                param('timeout', (ref9 = cfg.httapi_timeout) != null ? ref9 : 120);
                // Force very low cache (cannot be zero because mod_httapi both uses >-1 and >0 in its code).
                param('file-cache-ttl', 1);
                param('abs-file-cache-ttl', 1);
                // Use file-not-found-expires=1 to force cache bypass
                return param('file-not-found-expires', 1);
              });
            });
          });
        });
        configuration({
          name: 'conference.conf'
        }, function() {
          callerControls(function() {
            return group({
              name: 'default'
            }, function() {
              control({
                action: 'mute',
                digits: '1'
              });
              control({
                action: 'deaf mute',
                digits: '2'
              });
              return control({
                action: 'hangup',
                digits: '3'
              });
            });
          });
          return profiles(function() {
            return profile({
              name: 'default'
            }, function() {
              param('rate', 16000);
              param('interval', 20);
              param('enter-sound', 'tone_stream://%(200,0,500,600,700)');
              param('exit-sound', 'tone_stream://%(500,0,300,200,100,50,25)');
              return param('sound-prefix', '');
            });
          });
        });
        // See RFC4975, RFC4976, RFC7701, RFC7977.
        return configuration({
          name: 'msrp.conf'
        }, function() {
          return settings(function() {
            return param('listen-ip', '::1');
          });
        });
      });
      // cfg.sound_dir (string) Location of the sound files (default: `/opt/freeswitch/share/freeswitch/sounds`)
      sound_dir = (ref3 = cfg.sound_dir) != null ? ref3 : '/opt/freeswitch/share/freeswitch/sounds';
      if (process.env.WITH_SOUNDS === 'true' || (process.env.WITH_SOUNDS == null)) {
        return section('phrases', function() {
          return macros(function() {
            var i, len, results;
            results = [];
            for (i = 0, len = phrases_to_load.length; i < len; i++) {
              module = phrases_to_load[i];
              results.push((module.include(sound_dir))(cfg));
            }
            return results;
          });
        });
      }
    });
  });

}).call(this);
