// Generated by CoffeeScript 2.3.2
(function() {
  var debug, hostname, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:forward:basic`;

  debug = (require('tangible'))(this.name);

  ({hostname} = require('os'));

  this.include = async function() {
    var fr_inv_timeout, ref, ref1;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'forward') {
      return;
    }
    this.report({
      state: 'forward'
    });
    debug('forwarding on behalf of', this.session.endpoint_name);
    this.session.endpoint = (await this.cfg.prov.get(`endpoint:${this.session.endpoint_name}`));
    this.session.outbound_route = this.session.endpoint.outbound_route;
    this.session.forwarding = true;
    if (this.cfg.mask_source_on_forward) {
      this.session.source = this.source;
      this.source = this.destination;
    }
    this.destination = this.session.destination;
    this.direction('egress');
    await this.user_tags(this.session.endpoint.tags);
    // Reset the ringer timeout (which was set in `post`)
    fr_inv_timeout = 90;
    switch (false) {
      case !(this.cfg.answer_on_forward || this.session.answer_on_forward):
        debug('answer on forward');
        await this.action('answer'); // 200
        this.session.sip_wait_for_aleg_ack = false;
        await this.export({
          sip_wait_for_aleg_ack: this.session.sip_wait_for_aleg_ack
        });
        break;
      case !(this.cfg.preanswer_on_forward || this.session.preanswer_on_forward):
        debug('pre_answer on forward');
        await this.action('pre_answer'); // 183
        break;
      case !(this.cfg.ringready_on_forward || this.session.ringready_on_forward):
        debug('ring_ready on forward');
        await this.action('ring_ready'); // 180
    }
    
    // FIXME the original URI part should be the Request-URI per RFC5806
    await this.export({
      sip_h_Diversion: `<sip:${this.destination}@${(ref1 = this.cfg.host) != null ? ref1 : hostname()}>;reason=${this.session.reason}`,
      originate_timeout: fr_inv_timeout,
      bridge_answer_timeout: fr_inv_timeout
    });
    this.report({
      state: 'pre-forward',
      endpoint: this.session.endpoint._id
    });
    debug('OK', {
      'session.outbound_route': this.session.outbound_route,
      'session.direction': this.session.direction,
      'session.forwarding': this.session.forwarding,
      'session.source': this.session.source,
      'source': this.source,
      'destination': this.destination
    });
  };

}).call(this);
