// Generated by CoffeeScript 2.3.2
(function() {
  var debug, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:ingress:centrex-redirect`;

  debug = (require('tangible'))(this.name);

  this.include = async function() {
    var is_remote, queuer_call, ref, res, server, uri;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'ingress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    // Transfer Workaround
    // -------------------
    is_remote = (await this.cfg.is_remote(this.session.number_domain, [this.session.local_server, this.session.client_server].join('/')));
    if (is_remote) {
      server = is_remote.split('/')[0];
      this.report({
        state: 'centrex-redirect',
        server
      });
      uri = `<sip:${this.session.ccnq_to_e164}@${server};xref=${this.session.reference}>`;
      debug('Handling is remote', uri);
      // Send a REFER to the carrier-side SBC.
      res = (await this.action('deflect', uri));
      debug('Redirection returned', uri, res);
      // Make sure there is no further processing.
      this.direction('transferred');
      return;
    }
    // Centrex Handling
    // ----------------

    // Monitor the a-leg.
    if ((this.cfg.queuer != null) && (this.queuer_call != null)) {
      queuer_call = (await this.queuer_call());
    }
    return debug('Handling is local');
  };

}).call(this);
