// Generated by CoffeeScript 2.3.2
(function() {
  var debug, pkg, set_params;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:ingress:post-forward`;

  debug = (require('tangible'))(this.name);

  // Call-Handler
  // ============

  // This is a simplified version of the `middleware/client/ingress/post` handler.
  // Its only purpose is to route Centrex internal forwarded calls.
  // All attributes set on the initial call are kept as much as possible.
  this.include = async function() {
    var base, dst_number, parameters, ref, to_uri;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'ingress') {
      return;
    }
    if (this.session.forwarding !== true) {
      return;
    }
    debug('Ready', {
      dialplan: this.session.dialplan,
      country: this.session.country,
      destination: this.destination,
      number_domain: this.session.number_domain
    });
    if (this.session.dialplan === 'e164') {
      return this.respond('484');
    }
    dst_number = (await this.validate_local_number());
    await set_params.call(this);
    // Build the destination FreeSwitch dialstring
    // -------------------------------------------
    parameters = [];
    to_uri = `sip:${this.session.endpoint_name}`;
    if (!to_uri.match(/@/)) {
      to_uri = `sip:${this.destination}@${this.cfg.ingress_target}`;
    }
    if (this.session.number.endpoint_via != null) {
      parameters.push(`sip_network_destination=${this.session.number.endpoint_via}`);
    }
    if ((base = this.session).initial_destinations == null) {
      base.initial_destinations = [{parameters, to_uri}];
    }
    if (this.session.dev_logger) {
      await this.reference.set_dev_logger(true);
    }
    debug('Done.');
  };

  // `set_params`
  // ============

  // Most parameters have been set before the forwarding happened.
  // We only tweak a few things for the actual destination endpoint.
  set_params = async function() {
    var dlg_timeout, ref;
    debug('set_params');
    dlg_timeout = (ref = this.session.number.dialog_timer) != null ? ref : 28000; // 8h
    debug('schedule hangup');
    await this.action('sched_hangup', `+${dlg_timeout}`);
    await this.export({
      'sip_h_X-En': this.session.endpoint_name
    });
    debug('set_params: done.');
  };

}).call(this);
