// Generated by CoffeeScript 2.3.2
(function() {
  var compile, debug;

  this.name = "huge-play:middleware:client:menu";

  debug = (require('tangible'))(this.name);

  compile = require('flat-ornament/compile');

  this.description = 'Handles routing to a given menu.';

  this.include = async function() {
    var fun, ref;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'menu') {
      return;
    }
    if (this.session.menu == null) {
      debug('Missing menu data.');
      return;
    }
    this.report({
      state: 'menu'
    });
    await this.action('answer');
    this.session.sip_wait_for_aleg_ack = false;
    await this.export({
      t38_passthru: false,
      sip_wait_for_aleg_ack: this.session.sip_wait_for_aleg_ack
    });
    await this.set({
      sip_wait_for_aleg_ack: this.session.sip_wait_for_aleg_ack
    });
    debug('Menu starting.');
    this.menu_depth = 0;
    fun = compile(this.session.menu, this.ornaments_commands);
    if (fun != null) {
      await fun.call(this).catch((error) => {
        return debug.dev('Menu', error);
      });
    } else {
      debug.dev('Compilation failed', this.session.menu);
    }
    debug('Menu completed.');
  };

}).call(this);
