// Generated by CoffeeScript 2.3.2
(function() {
  var BlueRing, BlueRingReference, EventEmitter2, FS, LRU, Moment, RedRingAxon, Redis, RedisInterface, RedisInterfaceReference, assert, br, days, debug, default_wrapper, foot, heal, minutes, nimble, now, pkg, seconds, weeks,
    hasProp = {}.hasOwnProperty;

  nimble = require('nimble-direction');

  pkg = require('../package.json');

  ({EventEmitter2} = require('eventemitter2'));

  Moment = require('moment-timezone');

  this.name = `${pkg.name}:middleware:setup`;

  assert = require('assert');

  FS = require('esl');

  LRU = require('lru-cache');

  RedRingAxon = require('red-rings-axon');

  BlueRing = require('blue-rings');

  RedisInterface = require('normal-key/interface');

  Redis = require('ioredis');

  ({RedisInterfaceReference, BlueRingReference} = require('./reference'));

  ({debug, foot, heal} = (require('tangible'))(this.name));

  seconds = 1000;

  minutes = 60 * seconds;

  days = 24 * 60 * minutes;

  weeks = 7 * days;

  now = function(tz = 'UTC') {
    return Moment().tz(tz).format();
  };

  default_wrapper = null;

  br = null;

  this.end = function() {
    var ref;
    default_wrapper.end();
    br.end();
    return (ref = this.cfg.local_redis_client) != null ? ref.end() : void 0;
  };

  this.config = async function() {
    await nimble(this.cfg);
    return assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
  };

  this.server_pre = async function() {
    var HugePlayReference, _api, _wrapper, base, base1, base2, call_timeout, i, len, make_a_redis, redis_interface, ref, ref1, seed, seeds;
    // Red-Rings Axon connexion

    // * cfg.axon RedRingAxon configuration
    this.cfg.rr = new RedRingAxon((ref = this.cfg.axon) != null ? ref : {});
    // Prepare counters and registers

    // * cfg.blue_rings BlurRing (including Axon) configuration
    if ((base = this.cfg).blue_rings == null) {
      base.blue_rings = {};
    }
    if ((base1 = this.cfg.blue_rings).Value == null) {
      base1.Value = BlueRing.integer_values;
    }
    this.cfg.br = br = BlueRing.run(this.cfg.blue_rings);
    // Seed initial values if provided

    // * cfg.blue_rings.seeds[] Initial values for blue-rings, including `.counter` or `.register`.
    ({seeds} = this.cfg.blue_rings);
    ref1 = seeds != null ? seeds : [];
    for (i = 0, len = ref1.length; i < len; i++) {
      seed = ref1[i];
      switch (false) {
        case seed.counter == null:
          this.cfg.br.setup_counter(seed.name, seed.expire);
          this.cfg.br.update_counter(seed.name, seed.counter);
          break;
        case seed.register == null:
          this.cfg.br.setup_text(seed.name, seed.expire);
          this.cfg.br.update_text(seed.name, seed.register);
      }
    }
    // TBD: load from backup / database
    await nimble(this.cfg);
    assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
    // Local Redis
    // -----------
    make_a_redis = (label, config) => {
      var a_redis;
      a_redis = Redis.createClient(config);
      a_redis.on('error', (error) => {
        var ref2, ref3;
        return debug(`${label}: ${error.command} ${(ref2 = error.args) != null ? ref2.join(' ') : void 0}: ${(ref3 = error.stack) != null ? ref3 : error}`);
      });
      a_redis.on('ready', () => {
        return debug(`${label}: ready`);
      });
      a_redis.on('connect', () => {
        return debug(`${label}: connect`);
      });
      a_redis.on('reconnecting', () => {
        return debug(`${label}: reconnecting`);
      });
      a_redis.on('end', () => {
        return debug(`${label}: end`);
      });
      a_redis.on('warning', () => {
        return debug(`${label}: warning`);
      });
      return a_redis;
    };
    // * @cfg.local_redis (Optional, recommended) If present, used as the configuration for a local redis server.
    if (this.cfg.local_redis != null) {
      this.cfg.local_redis_client = make_a_redis('local redis', this.cfg.local_redis);
    }
    // How long should we keep a reference after the last update?
    call_timeout = 8 * 3600;
    if (this.cfg.use_bluerings_for_reference || (this.cfg.local_redis_client == null)) {
      HugePlayReference = (function() {
        class HugePlayReference extends BlueRingReference {};

        HugePlayReference.prototype.interface = br;

        HugePlayReference.prototype.timeout = call_timeout;

        return HugePlayReference;

      }).call(this);
    } else {
      redis_interface = new RedisInterface(this.cfg.local_redis_client, call_timeout);
      HugePlayReference = (function() {
        class HugePlayReference extends RedisInterfaceReference {};

        HugePlayReference.prototype.interface = redis_interface;

        HugePlayReference.prototype.timeout = call_timeout;

        return HugePlayReference;

      }).call(this);
    }
    this.cfg.Reference = HugePlayReference;
    // Period
    // ------

    // Used by billing code.
    if ((base2 = this.cfg).period_of == null) {
      base2.period_of = function(stamp = new Date(), timezone = 'UTC') {
        return Moment.tz(stamp, timezone).format('YYYY-MM');
      };
    }
    // Is-remote Cache
    // ---------------

    // Use blue-rings to retrieve the server on which this call should be hosted, and set it to `local_server` if none was previously set.
    // Returns either:
    // - `false` to indicate the call should be handled locally;
    // - the value previously stored if it is available;
    // - `null` if the determination could not be made (for example due to parameter, configuration, or server error).

    // If the `local_server` parameter is not provided (it normally should), only the previously stored value is checked. This should never be used when dealing with calls, since it means the call might not go through.
    this.cfg.is_remote = (name, local_server) => {
      var coherent, first_time, key, server;
      if (name == null) {
        return null;
      }
      key = `server for ${name}`;
      [coherent, server] = this.cfg.br.get_text(key);
      // Just probing (this is only useful when retrieving data, never when handling calls).
      if (local_server == null) {
        switch (server != null ? server.substring(0, this.cfg.host.length) : void 0) {
          case null:
            return null;
          case this.cfg.host:
            return false;
          default:
            return server;
        }
      }
      // Probe-and-update
      first_time = server == null;
      if (first_time) {
        this.cfg.br.setup_text(key, Date.now() + 1 * minutes);
        [coherent, server] = this.cfg.br.update_text(key, local_server, Date.now() + 2 * weeks);
      }
      // Check whether handling is local (assuming FreeSwitch is co-hosted, which is our standard assumption).
      debug('Checking for local handling', server, local_server);
      switch (server) {
        case null:
          debug.ops('Something failed');
          return null;
        case local_server:
          debug('Handling is local');
          this.cfg.br.update_text(key, server, Date.now() + 1 * weeks);
          return false;
        default:
          debug('Handling is remote');
          return server;
      }
    };
    // FreeSwitch API Client
    // ---------------------

    // These methods parallel the ones in black-metal/api.
    // Eventually the two should be merged.

    // Create a new socket client
    _wrapper = () => {
      var options, ref2, ref3;
      options = {
        host: (ref2 = this.cfg.socket_host) != null ? ref2 : '127.0.0.1',
        port: (ref3 = this.cfg.socket_port) != null ? ref3 : 5722
      };
      return FS.createClient(options);
    };
    // Use a default client for generic / shared APIs
    default_wrapper = (await _wrapper());
    _api = async function(cmd) {
      var res;
      return res = (await default_wrapper.client.bgapi(cmd));
    };
    // * cfg.api(command) returns (a Promise for) the body of the response for a FreeSwitch `api` command.
    this.cfg.api = async(cmd) => {
      var ref2, res;
      debug('api', cmd);
      res = (await _api(cmd));
      return (ref2 = res != null ? res.body : void 0) != null ? ref2 : null;
    };
    // * cfg.api.send(command) returns (a Promise for) the `esl` response to the command.
    this.cfg.api.send = _api;
    // * cfg.api.truthy(command) returns (a Promise for) a boolean indicating the success of the command.
    this.cfg.api.truthy = (cmd) => {
      var on_failure, on_success;
      debug('api.truthy', cmd);
      on_success = function(res) {
        debug('api.truthy', cmd, res);
        switch (false) {
          case res.uuid == null:
            return res.uuid;
          case res.body !== 'true':
            return true;
          case res.body !== 'false':
            return false;
          case res.body[0] !== '-':
            return false;
          default:
            return true;
        }
      };
      on_failure = function(error) {
        debug('api.truthy', cmd, error);
        return false;
      };
      return _api(cmd).then(on_success, on_failure);
    };
  };

  // Web
  // ---
  this.web = function() {
    return this.cfg.versions[pkg.name] = pkg.version;
  };

  // Context Extension
  // -----------------
  this.include = function(ctx) {
    var _bus, k, ref, v;
    _bus = new EventEmitter2();
    ctx.call.on('error', function(error) {
      return debug.dev('Call Failure', error);
    });
    ref = {
      on: function(ev, cb) {
        return _bus.on(ev, cb);
      },
      once: function(ev, cb) {
        return _bus.once(ev, cb);
      },
      emit: function(ev, data) {
        return _bus.emit(ev, data);
      },
      end: function() {
        _bus.removeAllListeners();
        this.call = null;
        this.session = null;
        this.reference = null;
      },
      sleep: function(timeout) {
        return new Promise(function(resolve) {
          return setTimeout(resolve, timeout);
        });
      },
      direction: function(direction) {
        var ref;
        if ((ref = this.session) != null) {
          ref.direction = direction;
        }
        this.emit('direction', direction);
        return this.report({
          event: 'direction',
          direction
        });
      },
      report: async function(report) {
        var ref, ref1, ref2;
        if (!((this.call != null) && (this.session != null) && (this.reference != null))) {
          debug.dev('report: improper environment');
          return false;
        }
        if (report.old_state == null) {
          report.old_state = this.session.state;
        }
        if (report.state != null) {
          this.session.state = report.state;
        }
        if (report.timezone == null) {
          report.timezone = this.session.timezone;
        }
        if (report.timestamp == null) {
          report.timestamp = now(report.timezone);
        }
        report.now = Date.now();
        if (report.host == null) {
          report.host = this.cfg.host;
        }
        if (report.type == null) {
          report.type = 'report';
        }
        if (report.source == null) {
          report.source = this.source;
        }
        if (report.destination == null) {
          report.destination = this.destination;
        }
        if (report.direction == null) {
          report.direction = this.session.direction;
        }
        if (report.dialplan == null) {
          report.dialplan = this.session.dialplan;
        }
        if (report.country == null) {
          report.country = this.session.country;
        }
        if (report.number_domain == null) {
          report.number_domain = this.session.number_domain;
        }
        if (report.number_domain == null) {
          report.number_domain = (await this.reference.get_number_domain());
        }
        if (report.number_domain_dialplan == null) {
          report.number_domain_dialplan = (ref = this.session.number_domain_data) != null ? ref.dialplan : void 0;
        }
        if (report.agent == null) {
          report.agent = this.session.agent;
        }
        if (report.agent_name == null) {
          report.agent_name = this.session.agent_name;
        }
        if (report.endpoint == null) {
          report.endpoint = (ref1 = this.session.endpoint) != null ? ref1.endpoint : void 0;
        }
        if (report.endpoint == null) {
          report.endpoint = (ref2 = this.session.number) != null ? ref2.endpoint : void 0;
        }
        if (report.endpoint == null) {
          report.endpoint = this.session.endpoint_name;
        }
        if (report.endpoint == null) {
          report.endpoint = (await this.reference.get_endpoint());
        }
        report.call = this.call.uuid;
        report.reference = this.session.reference;
        report.report_type = 'call';
        if (report.agent != null) {
          this.cfg.rr.notify(`agent:${report.agent}`, `call:${report.call}`, report);
        }
        if (report.endpoint != null) {
          this.cfg.rr.notify(`endpoint:${report.endpoint}`, `call:${report.call}`, report);
        }
        if (report.number_domain != null) {
          this.cfg.rr.notify(`number_domain:${report.number_domain}`, `call:${report.call}`, report);
        }
        return true;
      },
      notify: function(report) {
        report._notify = true;
        return this.report(report);
      },
      set: async function(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.set(name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          await this.res.set(k, v);
        }
      },
      unset: async function(name) {
        var i, len;
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.set(name, null);
          return;
        }
        for (i = 0, len = name.length; i < len; i++) {
          k = name[i];
          await this.res.set(k, null);
        }
      },
      export: async function(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.export(name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          await this.res.export(k, v);
        }
      },
      respond: function(response) {
        var ref, ref1, ref2;
        this.notify({
          state: 'immediate-response',
          response: response
        });
        if ((ref = this.session) != null) {
          if (ref.first_response_was == null) {
            ref.first_response_was = response;
          }
        }
        this.direction('responded');
        if (((ref1 = this.session) != null ? ref1.alternate_response : void 0) != null) {
          return (ref2 = this.session) != null ? ref2.alternate_response(response) : void 0;
        } else {
          return ctx.action('respond', response);
        }
      },
      sofia_string: async function(number, extra_params = []) {
        var destination, id, number_data, params, to_uri;
        debug('sofia_string', number, extra_params);
        id = `number:${number}@${this.session.number_domain}`;
        number_data = (await this.cfg.prov.get(id).catch(function(error) {
          var ref;
          debug.ops(`${id} ${(ref = error.stack) != null ? ref : error}`);
          return {};
        }));
        if (number_data.number == null) {
          return '';
        }
        destination = number_data.number.split('@')[0];
        to_uri = `sip:${number_data.endpoint}`;
        if (!to_uri.match(/@/)) {
          to_uri = `sip:${destination}@${this.cfg.ingress_target}`;
        }
        if (number_data.endpoint_via != null) {
          extra_params.push(`sip_network_destination=${number_data.endpoint_via}`);
        }
        params = [...extra_params, `sip_h_X-En=${number_data.endpoint}`];
        return `[${params.join(',')}]sofia/${this.session.sip_profile}/${to_uri}`;
      },
      validate_local_number: async function() {
        var base, base1, dst_number;
        dst_number = `${this.destination}@${this.session.number_domain}`;
        this.session.number = (await this.cfg.prov.get(`number:${dst_number}`).catch(function(error) {
          return {
            disabled: true,
            error
          };
        }));
        await this.user_tags(this.session.number.tags);
        if (this.session.number.timezone != null) {
          if ((base = this.session).timezone == null) {
            base.timezone = this.session.number.timezone;
          }
        }
        if (this.session.number.music != null) {
          if ((base1 = this.session).music == null) {
            base1.music = this.session.number.music;
          }
        }
        if (this.session.number.error != null) {
          debug.dev(`Could not locate destination number ${dst_number}`);
          this.notify({
            state: 'invalid-local-number',
            number: this.session.number._id
          });
          await this.respond('486 Not Found');
          return;
        }
        debug(`validate_local_number: Got dst_number ${dst_number}`, this.session.number);
        if (this.session.number.disabled) {
          debug.ops(`Number ${dst_number} is disabled`);
          this.notify({
            state: 'disabled-local-number',
            number: this.session.number._id
          });
          await this.respond('486 Administratively Forbidden');
          return;
        }
        this.session.endpoint_name = this.session.number.endpoint;
        await this.reference.set_endpoint(this.session.number.endpoint);
        await this.reference.set_account(this.session.number.account);
        this.report({
          state: 'validated-local-number',
          number: this.session.number._id,
          endpoint: this.session.endpoint_name,
          account: this.session.number.account
        });
        return dst_number;
      },
      local_redis: this.cfg.local_redis_client,
      user_tag: async function(tag) {
        if (this.reference == null) {
          debug.dev('user_tag: missing @reference', tag);
          return;
        }
        if (tag != null) {
          await this.reference.add_('user-tag', tag);
          heal(this.report({
            event: 'user-tag',
            tag
          }));
        }
      },
      user_tags: async function(tags) {
        var i, len, tag;
        if (tags == null) {
          return;
        }
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          await this.user_tag(tag);
        }
      },
      has_user_tag: async function(tag) {
        if (this.reference == null) {
          debug.dev('has_user_tag: missing @reference', tag);
          return false;
        }
        return (tag != null) && (await this.reference.has_('user-tag', tag));
      },
      clear_user_tags: async function() {
        if (this.reference == null) {
          debug.dev('clear_user_tags: missing @reference');
          return;
        }
        await this.reference.clear_('user-tag');
      },
      record_call: function(name, metadata = {}) {
        var keep_recording, ref, ref1, ref2, ref3, ref4, ref5, ref6;
        if (this.cfg.recording_uri == null) {
          debug.dev('No recording_uri, call will not be recorded.');
          return false;
        }
        Object.assign(metadata, {
          name: name,
          number_domain: (ref = this.session) != null ? ref.number_domain : void 0,
          number: (ref1 = this.session) != null ? (ref2 = ref1.number) != null ? ref2._id : void 0 : void 0,
          agent: (ref3 = this.session) != null ? ref3.agent : void 0,
          timezone: (ref4 = this.session) != null ? ref4.timezone : void 0,
          groups: (ref5 = this.session) != null ? (ref6 = ref5.number) != null ? ref6.allowed_groups : void 0 : void 0,
          source: this.source,
          destination: this.destination,
          call_start: new Date().toJSON(),
          recording_start: new Date().toJSON()
        });
        keep_recording = async() => {
          var last_uri, outcome, still_running, uri, uuid;
          ({uuid} = this.call);
          uri = (await this.cfg.recording_uri(name, metadata));
          debug('Recording', uuid, uri);
          outcome = (await this.cfg.api(`uuid_record ${uuid} start ${uri}`));
          this.report(Object.assign({
            event: 'recording',
            uri
          }, metadata));
          debug('Recording', uuid, uri, outcome);
          last_uri = uri;
          still_running = true;
          this.call.once('CHANNEL_HANGUP_COMPLETE', function() {
            return still_running = false;
          });
          while (still_running) {
            await this.sleep(29 * minutes);
            if (still_running) {
              metadata.recording_start = new Date().toJSON();
              uri = (await this.cfg.recording_uri(name, metadata));
              debug('Recording next segment', uuid, uri);
              await this.cfg.api(`uuid_record ${uuid} start ${uri}`);
              this.report(Object.assign({
                event: 'recording',
                uri
              }, metadata));
            }
            await this.sleep(1 * minutes);
            debug('Stopping previous segment', uuid, last_uri);
            await this.cfg.api(`uuid_record ${uuid} stop ${last_uri}`);
            last_uri = uri;
          }
        };
        keep_recording().catch((error) => {
          var ref7;
          return debug(`record_call: ${(ref7 = error.stack) != null ? ref7 : error}`);
        });
        debug('Going to record', name);
        return true;
      }
    };
    // Data reporting (e.g. to save for managers reports).
    // Typically `@report({state,…})` for calls state changes / progress, `@report({event,…})` for non-calls.
    // This version is meant to be used in-call.
    // _This_ is highly ambiguous since it could be _any_ endpoint along the chaing of forwardings, transfers, etc.
    // We have no real way to know, though, and removing it (for example in middleware/client/ingress/pre) could lead to issues.
    // Real-time notification (e.g. to show on a web panel).
    // Prevent extraneous processing of this call.
    // This is a simplified version of the sofia-target (session.initial_destinations) building code found in middleware:client:ingress:post.
    // This is a simplified version of the sofia-string building code found in middleware:client:ingress:send.

    // * hdr.X-En Endpoint name, set when dialing numbers.
    // Retrieve number data.

    // * session.number (object) The record of the destination number interpreted as a local-number in `session.number_domain`.
    // * doc.local_number.disabled (boolean) If true the record is not used.
    // was 403
    // Set the endpoint name so that if we redirect to voicemail the voicemail module can locate the endpoint.
    // Set the account so that if we redirect to an external number the egress module can find it.
    // User tags
    // Record call
    // Keep recording (async)
    for (k in ref) {
      if (!hasProp.call(ref, k)) continue;
      v = ref[k];
      ctx[k] = v;
    }
  };

}).call(this);
